#!/usr/bin/php
<?php
define('DRIVER','/usr/local/esia/plugins/lib/bareosdrv.py');

function run($params,$command,$json=false){
	$host = $params['host'];
	$pass = $params['pass'];
	$cmd = DRIVER." -a $host -P $pass -c '$command'";

	if( $json ) $cmd = "$cmd -j";

	exec($cmd,$output,$ret);

	if( $json ) return json_decode($output[0],true);
	return $output;
}

function pareConsole(l$ines){
	$items =array();
	$parse = implode('|',$lines);
	if( !preg_match_all('/(\w+)\s*\|*{([^}]*)/',$parse,$matches)) return array();

	foreach($matches[2] as $match){
		$item = array();
		if( preg_match_all('/([^|=]*)=([^|]*)/',$match,$matches2)){
			for($i=0;$i<count($matches2[1]);$i++){
				$key = trim($matches2[1][$i]);
				$value = trim(trim($matches2[2][$i]),'"');
				$item[$key]=$value;
			}
			$items[]=$item;
		}
	}
	return $items;
}

function getDirectorStatus($params){
	$time = run($params,'time',true);
	$arr['system']['time'] = $time['time'];
	$status = run($params,'memory',false);

	$pattern = '/^(\S+)\s+[Vv]ersion:\s+(\S+\s+\([^\)]*\))\s+(\S+)\s+\w+\s+(.*)/';	
	if( preg_match($pattern,$status[0],$matches)){
		$arr['system']['name'] = $matches[1];
		$arr['system']['version'] = $matches[2];
		$arr['system']['arch'] = $matches[3];
		$arr['system']['os'] = $matches[4];	
	}

	$pattern = '/started\s([^\.]*)\..*run=(\d+).*running=(\d+).*mode=(\d+).*db=(\w+)/';
	if ( preg_match($pattern,$status[1],$matches)){
		$arr['system']['processtime']=$matches[1];
		$arr['jobs']['run']=$matches[2];
		$arr['jobs']['runned']=$matches[3];
		$arr['jobs']['mode']=$matches[1];
		$arr['system']['db']=$matches[1];
	}

	return $arr;
}

function getClientsList($params){
	return run($params,'list clients',true)['clients'];
}

function getStoragesList($params){
	return run($params,'list storages',true)['storages'];
}

function getHostsList($params){
	$type = $params['type'];
	$type .= 's';
	return run($params,"list $type",true)[$type];
}

function getHostStatus($params){
        $name = $params['name'];
        $type = $params['type'];

        $status = run($params,"status $type=$name",false);

        $pattern = '/(\d+\.\d+\.\d\.\d+):(\d+)/';
        if( preg_match($pattern,$status[0],$matches)){
                $arr['socket']['addr'] = $matches[1];
                $arr['socket']['port'] = $matches[2];
        }

        $pattern = '/^(\S+)\s+[Vv]ersion:\s+(\S+\s+\([^\)]*\))\s+(\S+)\s+\w+\s+(.*)/';
        if( preg_match($pattern,$status[2],$matches)){
                $arr['system']['name'] = $matches[1];
                $arr['system']['version'] = $matches[2];
                $arr['system']['arch'] = $matches[3];
                $arr['system']['os'] = $matches[4];
        }

        $pattern = '/started\s([^\.]*)\..*run=(\d+).*running=(\d+)/';
        if ( preg_match($pattern,$status[3],$matches)){
                $arr['system']['processtime']=$matches[1];
                $arr['jobs']['run']=$matches[2];
                $arr['jobs']['runned']=$matches[3];
        }

         $pattern = '/bwlimit=(\d+)(\wB\/s)/';
          if( preg_match($pattern,$status[5],$matches)){
                $arr['bwlimit']['value'] = $matches[1];
                $arr['bwlimit']['unit'] = $matches[2];
        }
        return $arr;
}

function getHostsStatus($params){
	$type = $params['type'];
	$hosts = getHostsList($params);
	foreach($hosts as $host ){
                $params['name'] = $host['name'];
                $tmp = getHostStatus($params);
                $tmp[$type] = $host;
                $arr[] = $tmp;
        }
        return $arr;
}

function getClientsStatus($params){
	$params['type'] = 'client';
	return getHostsStatus($params);
}

function getStoragesStatus($params){
	$params['type'] = 'storage';
	return getHostsStatus($params);
}

$callback_functions = array(
	'dcstatus' => 'getDirectorStatus',
	'fdstatus' => 'getClientsStatus',
	'sdstatus' => 'getStoragesStatus',
);

$options = getopt('a:P:c:');

$addr = $options['a'];
$pass = $options['P'];
$cmd  = $options['c'];

$ret = call_user_func($callback_functions[$cmd],array('host'=>$addr,'pass'=>$pass));
echo json_encode($ret,JSON_PRETTY_PRINT);
?>
