#!/usr/bin/python
import argparse
import bareos.bsock
import json

if __name__ == '__main__':
	parser = argparse.ArgumentParser(description='Execute a command on bareos director and return result.')
    	parser.add_argument('-a', '--address', required=True, help='address of bareos director.' )
	parser.add_argument('-p', '--port', type=int, default=9101, help='Port to connect to on the remote host. Default = 9101.' )
	parser.add_argument('-P', '--password', required=True, help='Password of remote bareos director.' )
	parser.add_argument('-c', '--command', default='help', help='Command to execute on bareos director. Default = "help".' )
	parser.add_argument('-j', '--json', action='store_true', default=False, help='Parse the output on json format if that is possible.' )
    	parser.add_argument('-v', dest='verbose', action='store_true')
    	args = parser.parse_args()

	password=bareos.bsock.Password(args.password)

	if args.json:
		directorconsole=bareos.bsock.DirectorConsoleJson(address=args.address, port=args.port, password=password)
		print json.dumps(directorconsole.call(args.command),encoding='ascii')
	else:
		directorconsole=bareos.bsock.DirectorConsole(address=args.address, port=args.port, password=password)
	        print directorconsole.call(args.command)
