<?php
//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$webp_name='Backup';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */

// Mode de compatibilité
if(!empty($_REQUEST['node']))
{
    $_GET['nodeid'] = $_REQUEST['node'];
}
if(!empty($_REQUEST['node_id']))
{
    $_GET['nodeid'] = $_REQUEST['node_id'];
}


include_once $path.'/inc/common_node_control.php';

include_once $path.$apache_plugin_path.'inc/common_page.inc.php';
include_once $path.$apache_plugin_path.'inc/Model_BackupSettings.php';
if(!isset($_REQUEST['action'])||$_REQUEST['action']=='update'||$_REQUEST['action']=='add')
{
	$drivers = Model_BackupSettings::getDrivers($dbconnection);

	$tmp = array();
	foreach($drivers as $value){
		$tmp[$value['id']] = $value['name'].' - '.$value['type'];
	}

	$advance_config_id = $_REQUEST['id'];
	include_once("$path/Model_adm.php");
	$advance_config=array_shift(Model_adm:: getAdvanceNodeConfig($dbconnection,null,$advance_config_id));
	$node_id = $advance_config['node_id'];


	$smarty->assign('node_id',$node_id);

	try
	{
		$settings = Model_BackupSettings::getDeviceDriverSettings($dbconnection,$node_id);
	}
	catch(Exception $ex)
	{

	}
	if(!empty($settings))
	{
		$settings = array_shift($settings);
		$smarty->assign('selected_driver',$settings['drv']);
		$smarty->assign('retention_days',$settings['retention']);
	}
	else
	{
		$smarty->assign('retention_days',15);
	}

	$smarty->assign('drivers',$tmp);

	$smarty->assign('url',$_SERVER['PHP_SELF']);
	$smarty->display($template_path.'main_admin.html');
}
elseif( $_REQUEST['action'] == 'getOptions' )
{ //Chargement des options du driver
	if(is_numeric($_REQUEST['backup_drv']))
	{
		$driver = Model_BackupSettings::getDriverById($dbconnection,$_REQUEST['backup_drv']);
		$options = Model_BackupSettings::getConfig($dbconnection,$_REQUEST['backup_drv'],$_REQUEST['node_id']);
		include_once($path.$driver['admin']);  //Génére du HTML
	}
}
elseif( $_REQUEST['action'] == 'update_drv_conf' )
{
	if(isset($_REQUEST['test']))
	{
		$driver = Model_BackupSettings::getDriverById($dbconnection,$_REQUEST['backup_drv']);
		$node = Model_esia::InstanceNode($dbconnection,$_REQUEST['node_id']);
		$plugin_path = rtrim($_SERVER['DOCUMENT_ROOT'],'/') . '/plugin/backup/drivers/' . $driver['name'].'/'.$driver['path'];

		//L'include_once permet de parser $_REQUEST afin de générer la variable $options;
		$setting['host'] = $node->getIPAddress();
		include_once($path.$driver['admin']);
		$parameters = json_decode($options,true);

		//Derrière une unity
		$gesasn=NULL;
		$gesa=Model_esia::getGesaLink($dbconnection,$_REQUEST['node_id']);
		if( is_a($gesa,'Device') ){
			$gesasn=Model_esia::getGesaSN($dbconnection,$gesa->getId());
		}
		if($gesasn!=NULL){
			$parameters['gesasn']=$gesasn;
		}

		$cmd = '-M getjobsids -O period=1h ';
		foreach($parameters as $key => $value){
			$cmd.= " -O $key=$value";
		}
		$cmd = "$plugin_path $cmd";
		$cmd = escapeshellcmd($cmd);

		for($i=0;$i<3;$i++){ //problème ecatp
			usleep($i*500);
			exec($cmd,$output,$ret);
			$output = implode("\n",$output);
			if( empty($output) ){
				$success=false;
			}
			else{
				$success=true;
				break;
			}
		}
		if( !$success || !is_array(json_decode($output,TRUE))){
			echo $lang['BCK_CONFIGTEST_ERROR']."\n";
			echo "$output\n";
		}
		else{
			echo $lang['BCK_CONFIGTEST_SUCCESS']."\n";
		}
	}
	else if(isset($_REQUEST['save']))
	{
		$node_id = $_REQUEST['node_id'];
		$backup_drv = $_REQUEST['backup_drv'];
		$retention = $_REQUEST['retention_days'];
		try
		{
			//On supprime l'ancien driver
			$settings = Model_BackupSettings::getDeviceDriverSettings($dbconnection,$node_id);
			if(!empty($settings))
			{
				$setting = array_shift($settings);
				if($setting['drv'] != $backup_drv)
				{
					Model_BackupSettings::removeConfig($dbconnection,$setting['drv'],$node_id,$options);
				}
			}
			else
			{
				$node = Model_esia::InstanceNode($dbconnection,$node_id);
				$setting['host'] = $node->getIPAddress();
			}

			//Chargement des options de driver
			$options = Model_BackupSettings::getConfig($dbconnection,$backup_drv,$node_id);
			if(is_numeric($backup_drv))
			{
				$driver = Model_BackupSettings::getDriverById($dbconnection,$backup_drv);
				include_once($path.$driver['admin']); //Configure la variable $option
			}

			//On ajoute le nouveau driver et sa configuration
			if(Model_BackupSettings::getConfig($dbconnection,$backup_drv,$node_id) == null)
			{
				Model_BackupSettings::addConfig($dbconnection,$backup_drv,$node_id,$options,$retention);
			}
			else if( $options != null )
			{ //On configure le driver actuel
				Model_BackupSettings::updateConfig($dbconnection,$backup_drv,$node_id,$options);
				Model_BackupSettings::updateRetention($dbconnection,$backup_drv,$node_id,$retention);
			}
			else
			{  //La retention a changée mais pas la config
				Model_BackupSettings::updateRetention($dbconnection,$backup_drv,$node_id,$retention);
			}
			$_SESSION['ADM_MESSAGE']=array('TYPE'=>'SUCCESS','MESSAGE'=>$lang['BCK_UPDATE_SUCCESS']);
			header('Location: /administration.php?admin=device&category=advancenode&action=list&id='.$node_id);
			exit(0);
			//https://10.7.0.43/administration.php?admin=device&category=advancenode&action=list&id=11
		}
		catch(Exception $ex)
		{
			$_SESSION['ADM_MESSAGE']=array('TYPE'=>'SUCCESS','MESSAGE'=>$lang['BCK_UPDATE_FAILED'].' '.$ex->getMessage());
			header('Location: /administration.php?admin=device&category=advancenode&action=list&id='.$node_id);
			exit(0);
		}
	}
	elseif(isset($_REQUEST['cancel']))
	{
		$node_id = $_REQUEST['node_id'];
		header('Location: /administration.php?admin=device&category=advancenode&action=list&id='.$node_id);
		exit(0);
	}
}
