<?php
/**
 * @name srv_control.php
* @description Fichier principal du plugin serveur
* @author Nicolas Biersart <n.biersart@esia-network.com>
* @contributor
* @copyright Nicolas Biersart 2012
* @license
* @esia 1.00
* @version 1.0.0
* @date 09/11/2012
*/

function search_services($name,$arr)
{
	foreach($arr as $service)
	{
		$match ='#'.$name.'#';
		if(preg_match($match,$service['name']))
		{
			return true;
		}
	}
	return false;
}

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$webp_name='Backup';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */

// Mode de compatibilité
if(!empty($_GET['id']))
{
    $_GET['nodeid'] = $_GET['id'];
}

include_once $path.'/inc/common_node_control.php';
include_once $path.$apache_plugin_path.'inc/common_page.inc.php';
$descr = htmlentities($node->getDescription() , ENT_QUOTES);
$smt_node = array('name'=>$node->getName(),
        'ip'=>$node->getIPv4Adress(),
        'id'=>$node->getId(),
		'description'=>$descr,
        'group'=>$node->getGroup()
);
$smarty->assign('node',$smt_node);

if(isset($_GET['action']) && $_GET['action'] == "add_checks")
{
	if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration"))
	{
		include_once $path.'/Model_adm.php';
	    $checks=$_GET;
	    unset($checks["id"]);
		unset($checks["nodeid"]);
		unset($checks["period"]);
	    unset($checks["action"]);
	    unset($checks["options"]);
	    unset($checks["server"]);
	    unset($checks["check"]);

	    $node=Model_esia::InstanceNode($dbconnection,$srv_id);
	    $services = Model_esia::getServices($dbconnection,$node->getId());
	    $plugin=Model_esia::getPlugin($dbconnection,$_GET["check"])[0];
	    foreach($checks as $key => $value)
	    {
	        if (is_array( $value ) )
	        {
	            $value = array_shift($value);
	        }
	        $checks[$key] = $_GET["options"];
	        $checks[$key]=str_replace('"<SRC_NAME>"','"<$POSTE_NAME>"',$checks[$key]);
	        $checks[$key]=str_replace('<SRC_NAME>','"<$POSTE_NAME>"',$checks[$key]);
	        $checks[$key]=str_replace('<$POSTE_NAME>', $value,$checks[$key]);

            $checks[$key]=str_replace('<JOB_NAME>','"<$JOB_NAME>"',$checks[$key]);
            $checks[$key]=str_replace('<$JOB_NAME>', $value,$checks[$key]);


		    if(empty($_GET["common"]))
		    {
		        $name = "BACKUPS $value";
		    }
		    else
		    {
		        $name=$_GET["common"]." ".$key;
		    }
		    if(! search_services($name,$services))
		    {
			    Model_adm::addService($dbconnection, $name, $plugin["id"], $node->getId(), $plugin["interval_time"], $checks[$key], $plugin["priority"],null,null);
		    }
	    }
		header('Location: '.$_SERVER['SCRIPT_NAME']."?id=$srv_id");
		exit(0);
	}
}
if(isset($_GET['tab']))
{
	$smarty->assign('tab',$_GET['tab']);
}
else
{
    $smarty->assign('tab',0);
}
$smarty->assign('l_hardware',$lang['SRV_HARDWARE']);
$smarty->assign('l_software',$lang['SRV_SOFTWARE']);
$smarty->assign('l_srv_report', $lang['REPORT']);
$smarty->assign('l_show_service', $lang['SHOW_SERVICE']);
$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);
$smarty->assign('control',$apache_path.'/bck_control.php');

if(!isset($_GET['action']) || $_GET['action'] == "add_checks")
{
	$smarty->display($template_path.'bck_control.html');
}
else if( $_GET['action'] == 'subtab' )
{
	$smarty->display($template_path.'bck_backup_nav.html');
}
?>
