#!/usr/bin/php
<?php
define('ECATP_PATH','/usr/local/esia/plugins/check_gesa');
define('PLUGIN_BIN','drv-appassure-snmp.php');

//Repository
$repositoryTableEntryFields = array(1=>'Index','Guid','Name','Type','Status','SizeMB','FreeMB');
$repositoryTypeEnum=array('unknown','dvm','o3e');
$repositoryStatusEnum=array('unknown','unmounting','unmounted','mounting','mounted','maintenance','error');

//Protected machine
$agentTableEntryFields = array(1=>'Index','Guid','Name','Type','Status','HostUri','RecoveryPointsCount','ReplicationStatus','ReplicationLast','VirtualStandbyStatus','VirtualStandbyLast','SqlCheckStatus','SqlCheckLast','ExchangeCheckStatus','ExchangeCheckLast');
$agentTypeEnum = array('protected','replicated','pendingFailover','failover','clusterNode','cluster','recoveryPointsOnly','esxServer','esxVirtualMachine','backup','unknown','hyperVServer','hyperVVirtualMachine','hyperVCluster');
$agentStatusEnum = array('online','pendingFailover','unreachable','authenticationError','failed','loading');

$options = getopt('A:M:O:');

$EXIT_SUCCESS=0;
$EXIT_NOT_IMPLEMENTED=-1;
$EXIT_ERROR=1;

if( !isset($options['M'])){
	echo "Parameter -M is missing\n"; exit($EXIT_ERROR);
}

$METHOD=$options['M'];
if(isset($options['O'])){
	if(is_array($options['O'])){
		$OPTIONS=$options['O'];
	}
	else{
		$OPTIONS=array($options['O']);
	}
}
else{
	$OPTIONS=array();
}

$action = strtolower($METHOD);

if(isset($options['A']) && is_readable($options['A'])){
	$options = json_decode(file_get_contents($options['A']),true);
}
else{
	$options = array();
}

foreach($OPTIONS as $opt){
	$exp=explode('=',$opt);
	$exp[0] = trim($exp[0]);
	$exp[1] = trim($exp[1]);
	
	if(count($exp) != 2 ) {
		echo "Incorrect Option -O format ($opt) must have format -O <name>=<value> -O <name>=<value> ... \n"; exit($EXIT_ERROR);
	}
	if( isset($options[$exp[0]]) ){
		echo "Option -O $opt overwrite another options parameter or auth file option\n"; exit($EXIT_ERROR);
	}
	
	$options[$exp[0]]=$exp[1];
}

if( empty($options['host']) ){
	echo "JSON file $AUTH_FILE hasn't required 'host' parameter\n"; exit($EXIT_ERROR);
}
if( empty($options['port']) ){
	$options['port'] = 8161;
}
if( empty($options['community']) ){
	echo "JSON file $AUTH_FILE hasn't required 'community' parameter\n"; exit($EXIT_ERROR);
}

//Si on à l'options gesasn, c'est qu'on doit passer à travers une unity
if( isset($options['gesasn'])){
	$gesasn = $options['gesasn'];
	unset($options['gesasn']);
	
	$parameters = "-M $action";
	foreach($options as $key => $value){
		$parameters.= " -O $key=$value";
	}
	
	$cmd = ECATP_PATH . " -G $gesasn -C ". PLUGIN_BIN . ' -A ' ."'$parameters'";
	for($i=0;$i<3;$i++){ //problème ecatp
		usleep($i*500);
		exec($cmd,$output,$ret);
		if( $ret != 0 ) {
			$success=false;
		}
		else{
			$success=true;
			break;
		}
	}
	$output = implode("\n",$output);
	if( $success && $action == 'getjobsvalues' ){
		$decode = json_decode($output,true);
		$decode = parse_drv_output($decode);
		$output = json_encode($decode,JSON_PRETTY_PRINT);
	}
		echo $output;
		exit($ret);
}

$session = new SNMP(0, $options['host'].':'.$options['port'], $options['community'],5000000);
switch($action){
	case 'getjobsids' :
		setFirewallRule($options['host'],true);
		$app_oids=identifyAppassureOIDs($session);
		$ret = getJobsIDS($result,$session,$app_oids,$options);
		flushFirewallRule($options['host']);
		break;
	case 'getjobsvalues' :
		setFirewallRule($options['host'],true);
		$app_oids=identifyAppassureOIDs($session);
		$ret = getJobsInfos($result,$session,$app_oids,$options);
		flushFirewallRule($options['host']);
		$result = parse_drv_output($result);
		break;
	default :
		echo "Method $action not implemented\n"; exit($EXIT_NOT_IMPLEMENTED);
}

echo json_encode($result,JSON_PRETTY_PRINT)."\n";
exit($ret);

function setFirewallRule($ip,$enable){
	if($enable){
		$method='I';
		$mode = 'enable';
	}
	else{
		$method='D';
		$mode = 'disable';
	}
	
	$cmd = 'iptables -'.$method." INPUT -p udp -j ACCEPT -s $ip 2>&1";
	exec($cmd,$output,$ret);
	
	if( $ret != 0 ){
		$output = implode("\n",$output);
		throw new Exception("Unable to $mode the firewall : $output");
	}
}

function flushFirewallRule($ip){
	try{
		while(true){
			setFirewallRule($ip,false);
		}
	}
	catch(Exception $ex){
	}
}

function parse_drv_output($arr){
	if( ! is_dir('/usr/local/esia/public_html') ) return $arr; //Nous sommes sur la Unity
	define('PUBLIC_HTML','/usr/local/esia/public_html/');
	$_SERVER['DOCUMENT_ROOT'] = PUBLIC_HTML;
	$path = PUBLIC_HTML;

	include_once $path."esia.conf.php";
	include_once MVCMODEL;

	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	$sth = $dbconnection->prepare("SELECT job_soft_id FROM backup_job WHERE job_soft_id LIKE ? ORDER BY job_end_time DESC LIMIT 1");

	$ret = array();
	foreach($arr as $row){
		$parsed = $row; 
		if( $row['end_time'] == '?DATETIME?' ){ //On génére une date si nouveau backup
			$exp = explode('_',$row['intern_id']);
			$job_id = $exp[1];
			$sth->execute(array("%_${job_id}_%"));
			
			$result=$sth->fetch(PDO::FETCH_ASSOC);
			$db_id = explode('_',$result['job_soft_id']);
			$db_id[0] = '?DATETIME?';
			$db_id = implode('_',$db_id);

			if(empty($result) || $db_id != $row['intern_id']){
				$dt = time();
				$parsed['start_time'] = $dt;
				$parsed['end_time'] = $dt;
				$exp[0] = $dt;
				$parsed['intern_id'] = implode('_',$exp);
			}
		}
		$ret[] = $parsed;
	}
	return $ret;
}

function identifyAppassureOIDs($session){
	$data = $session->get('.1.3.6.1.2.1.1.2.0');
	if( $data === false ) throw new Exception($session->getError());
	$base_oid = trim(explode(':',$data)[1]);
	return array(
			'base' => $base_oid,
			'repo_table' => $base_oid.'.200.1',
			'agent_table' => $base_oid.'.300.1',
	);
}

function period_to_ts($start){
	$start = strtolower($start);
	if(preg_match('/^[-]?(\d+)([hdwmy]?)$/',$start,$matches)){
		if(!empty($matches[2])){
			$matches[2]=strtoupper($matches[2]);
			switch($matches[2]){
				case 'H' :
					$since = time() - $matches[1] * 3600;
					break;
				case 'D' :
					$since = time() - $matches[1] * 86400;
					break;
				case 'W' :
					$since = time() - $matches[1] * 604800;
					break;
				case 'M' :
					$date = new DateTime();
					$date->sub(new DateInterval('P'.$matches[1].$matches[2]));
					$since=$date->format('U');
					break;
				case 'Y' :
					$date = new DateTime();
					$date->sub(new DateInterval('P'.$matches[1].$matches[2]));
					$since=$date->format('U');
					break;
			}
		}
		else $since = $matches[1];
	}
	else throw new Exception();
	
	return date('U',$since);
}

function parseSNMPTable($snmpTable){
	$ret = array();
	foreach($snmpTable as $key => $value){
		$exp = explode('.',$key);
		$k1 = array_pop($exp);
		$k2 = array_pop($exp);
		$v = trim(array_pop(explode(':',$value,2)),' "\t\n\r'); //blank char + '"'
		
		$ret[$k1][$k2] = $v;
	}
	return $ret;
}

function date_to_ts($date_str){
	$date_reg_pattern = '#\d{4}-\d{2}-\d{2},\d{2}:\d{2}:\d{2}#';
	$date_format = 'Y-m-d,H:i:s';
	
	if( preg_match($date_reg_pattern,$date_str,$matches)){
		$date = DateTime::createFromFormat($date_format,$matches[0],new DateTimeZone('GMT'));
		return $date->format('U');
	}
	return FALSE;
}

function date_between($date,$since,$last=null){
	if( $date === false || $since == false || $last == false) return false;
	if( $date < $since ) return false;
	if( $date > $last  ) return false;
	return true;
}

function generateID($ts,$guid,$rpc,$status){
	$ts = date_to_ts($ts);
	if( $rpc == 0 ) return FALSE;
	if(!is_numeric($ts)) $ts = '?DATETIME?';
	return "${ts}_${guid}_${rpc}_$status";
}

function getJobsIDs(&$result,$session,$app_oids,$options){
	$period_ts = period_to_ts($options["period"]);
	
	$agentTableEntryOids = array_flip( $GLOBALS['agentTableEntryFields']);
	$agentStatus = $GLOBALS['agentStatusEnum'];
	
	$guid_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['Guid']);
	$last_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['ReplicationLast']);
	$rpc_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['RecoveryPointsCount']);
	$status_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['Status']);
	
	$guid_data = parseSNMPTable($guid_data);
	$last_data = parseSNMPTable($last_data);
	$rpc_data = parseSNMPTable($rpc_data);
	$status_data = parseSNMPTable($status_data);
	
	$ids = array();
	foreach( $guid_data as $key => $guid ){
		$guid = array_shift($guid);
		$last = array_shift($last_data[$key]);
		$rpc = array_shift($rpc_data[$key]);
		$status = array_shift($status_data[$key]);
		$esia_status = getJobStatus($agentStatus[$status]);
		
		$id = generateID($last,$guid,$rpc,$esia_status);
		$ts = date_to_ts($last);
		
		if( $id !== FALSE && ( !is_numeric($last) || date_between($ts,$period_ts,time()) )){
			if( !isset($options['status']) || $esia_status == $options['status'] ){
				$ids[] = $id;
			}
		}
	}
	$result = array('ids'=>$ids);
	return $GLOBALS['EXIT_SUCCESS'];
}

function getJobStatus($status_backup){
	if( $status_backup == 'online' ){
		return 0;
	}
	elseif ( $status_backup == 'loading' ){
		return 1;
	}
	else{
		return 2;
	}
}

function getJobsInfos(&$result,$session,$app_oids,$options){
	$agentTableEntryOids = array_flip( $GLOBALS['agentTableEntryFields']);
	$agentType = $GLOBALS['agentTypeEnum'];
	$agentStatus = $GLOBALS['agentStatusEnum'];
	
	$ids=explode(',',$options['ids']);

	$guid_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['Guid']);	
	$last_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['ReplicationLast']);
	$rpc_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['RecoveryPointsCount']);
	$status_data = $session->walk($app_oids['agent_table'].'.'.$agentTableEntryOids['Status']);

	$guid_data = parseSNMPTable($guid_data);
	$last_data = parseSNMPTable($last_data);
	$rpc_data = parseSNMPTable($rpc_data);
	$status_data = parseSNMPTable($status_data);

	$result = array();
	foreach($ids as $wanted_id){
		$delete = false;
		foreach($guid_data as $rownum => $row){
			$row_guid = array_shift($row);
			$row_last = array_shift($last_data[$rownum]);
			$row_rpc = array_shift($rpc_data[$rownum]);
			$row_status = array_shift($status_data[$rownum]);

			$esia_status = getJobStatus($agentStatus[$row_status]);
			
			$row_id = generateID($row_last,$row_guid,$row_rpc,$esia_status);
			
			if( $row_id == $wanted_id ){
				$esiaAPI['intern_id']=$row_id;
				$esiaAPI['name']=trim(explode(':',$session->get($app_oids['agent_table'].'.'.$agentTableEntryOids['Name'].'.'.$rownum),2)[1],'" ');
				$esiaAPI['status_backup'] = $agentStatus[$row_status];
				$esiaAPI['status_esia'] = getJobStatus($esiaAPI['status_backup']);
				$esiaAPI['start_time'] = explode('_',$row_id)[0];
				$esiaAPI['end_time'] = $esiaAPI['start_time'];
				$esiaAPI['size'] = null;

				$type = trim(explode(':',$session->get($app_oids['agent_table'].'.'.$agentTableEntryOids['Type'].'.'.$rownum),2)[1]);
				$esiaAPI['type'] = $agentType[$type];

				$esiaAPI['source']=trim(explode(':',$session->get($app_oids['agent_table'].'.'.$agentTableEntryOids['HostUri'].'.'.$rownum),2)[1],'" ');
				
				if( preg_match('#https?:\/\/([^:\/]*)(:\d+)?\/apprecovery.*#',$esiaAPI['source'],$matches)){
					$esiaAPI['source'] = $matches[1];
				}
				
				$result[] = $esiaAPI;
				$delete = $rownum;
				break;
			}
		}
		if( $delete !== false ){
			unset($guid_data[$delete]);
		}
	}
	return $GLOBALS['EXIT_SUCCESS'];
}
?>
