<?php
function parse_size($size){
	$size /= 1024;
	$size /= 1024;
	$size = round($size,2);
	$size.= '&nbspMB';
	return $size;
}

function parse_duration($time){
	$time = round($time,0);
	return "$time s";
}

function arr_set_color(&$item,$key){
	foreach($item as $col => $value){
		if($col === 'name') continue;
		switch($value){
			case 0 : $status='EventOK'; break;
			case 1 : $status='EventWarning'; break;
			case 2 : $status='EventCritical'; break;
			case 3 : $status='EventUnknown'; break;
			case 4 : $status='EventPending'; break;
			default : $status='EventUnknown'; break;
		}
		
		$item[$col] = '';
		arr_set_class($item,$key,array($col,$status));
	}
}

function arr_set_status(&$item,$key){
	switch($item['esia_status']){
		case 0 : $status='EventOK'; break;
		case 1 : $status='EventWarning'; break;
		case 2 : $status='EventCritical'; break;
		case 3 : $status='EventUnknown'; break;
		case 4 : $status='EventPending'; break;
		default : $status='EventUnknown'; break;
	}

	$item['status'] = $item['intern_status'];
	arr_set_class($item,$key,array('status',$status));

	unset($item['intern_status']);
	unset($item['esia_status']);
}

function arr_parse_size(&$item,$key,$cols){
	$cols = explode(',',$cols);
	foreach($cols as $col){
		if(isset($item[$col])) $item[$col] = parse_size( $item[$col] );
	}
}

function arr_parse_duration(&$item,$key,$cols){
	$cols = explode(',',$cols);
	foreach($cols as $col){
		if(isset($item[$col])) $item[$col] = parse_duration( $item[$col] );
	}
}

function arr_parse_date(&$item,$key,$cols){
	$cols = explode(',',$cols);
	foreach($cols as $col){
		if(isset($item[$col])) {
			$item[$col] = date('d-m-Y H:i:s',$item[$col]);
		}
	}
}

function arr_parse_date_to_duration(&$item,$key,$params){
	$cols = $params[0];
	$lang = $params[1];
	
	$cols = explode(',',$cols);
	foreach($cols as $col){
		if(isset($item[$col])) {
			$d1 = new DateTime();
			$d1->setTimestamp($item[$col]);
			$d2 = new DateTime();
			$diff = $d2->diff($d1);
			
			if( $diff->y > 0 ) $value = $diff->y.' '.$lang['YEARS'];
			else if( $diff->m > 0 ) $value = $diff->m.' '.$lang['MONTHS'];
			else if( $diff->d > 0 ) $value = $diff->d.' '.$lang['DAYS'];
			else if( $diff->h > 0 ) $value = $diff->h.' '.$lang['HOURS'];
			else if( $diff->i > 0 ) $value = $diff->i.' '.$lang['MINUTES'];
			else if( $diff->s > 0 ) $value = $diff->s.' '.$lang['SECONDES'];
			
			$item[$col] = $value;
		}
	}
}

function arr_set_class(&$item,$key,$params){
	$cols = $params[0];
	$cl = $params[1];
	$cols = explode(',',$cols);
	foreach($cols as $col){
		if(isset($item[$col])) {
			if(empty($item[$col]['cl'])){
				$data = $item[$col];
				$item[$col] = array();
				$item[$col]['cl'] = $cl;
				if(empty($item[$col]['data'])) $item[$col]['data'] = $data;
			}
			else{
				$item[$col]['cl'] .= " $cl";
			}
		}
	}
}

function arr_set_attr(&$item,$key,$params){
	$cols = $params[0];
	$attr = $params[1];
	$cols = explode(',',$cols);
	foreach($cols as $col){
		if(isset($item[$col])) {
			$data = $item[$col];
			$item[$col] = array();
			$item[$col]['attr'] = $attr;
			if(empty($item[$col]['data'])) $item[$col]['data'] = $data;
		}
	}
}

function arr_organize_headers(&$item,$key,$cols){
	$row = array();
	$columns = explode(',',$cols[0]);
	$traductions =  explode(',',$cols[1]);
	for($i=0;$i<count($columns);$i++){
		$row[$traductions[$i]] = $item[$columns[$i]];
	}
	$item = $row;
}