<?php
/**
 * @name srv_control.php
* @description Fichier principal du plugin serveur
* @author Nicolas Biersart <n.biersart@esia-network.com>
* @contributor
* @copyright Nicolas Biersart 2012
* @license
* @esia 1.00
* @version 1.0.0
* @date 09/11/2012
*/

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'Backup');
include_once($path.$arr[0]['apache_path'].'inc/common_page.inc.php');

$node=Model_esia::InstanceNode($dbconnection,$_REQUEST['id']);
if($user->getAccess($dbconnection,"device_view",$node->getName()) ==1)
{
	if( !empty($_REQUEST['id']) && isset($_REQUEST['action']) && $_REQUEST['action'] == 'export'){
		if(isset($_REQUEST['start'])){
			$start = $_REQUEST['start'];
		}
		else {
			$start = '-1d';
		}
			
		if(preg_match('/^[-]?(\d+)([dwmy]?)$/',$start,$matches)){
			if(isset($matches[2])){
				$matches[2]=strtoupper($matches[2]);
				switch($matches[2]){
					case 'D' :
						$since = time() - $matches[1] * 86400; 
						break;
					case 'W' :
						$since = time() - $matches[1] * 604800;
						break;
					case 'M' :
						$date = new DateTime();
						$date->sub(new DateInterval('P'.$matches[1].$matches[2]));
						$since=$date->format('U');
						break;
					case 'Y' :
						$date = new DateTime();
						$date->sub(new DateInterval('P'.$matches[1].$matches[2]));
						$since=$date->format('U');
						break;
				}
			}
			else $since = $matches[1];
		}
		else{
			http_response_code(400);
			exit(0);
		}
		
		if(empty($_REQUEST['info'])){
			$jobstatus = Model_Backup::lastJobStatus($dbconnection,$_REQUEST['id'],$since);
			$data[$lang['LGD_OK']] 		= $jobstatus[0];
			$data[$lang['LGD_WARN']] 	= $jobstatus[1];
			$data[$lang['LGD_CRI']] 	= $jobstatus[2];
			//$data[$lang['LGD_UNKNOWN']] = $jobstatus[3];
			//$data[$lang['INPROGRESS']] = $jobstatus[4];
			if( array_sum($data) == 0 ) $data = array(); //On vide le tableau si on a aucune valeurs
			
			if( isset($_REQUEST['type'])){
				switch($_REQUEST['type']){
					case 'jsonC3' :
						$format_json['parameter'][0]['name'] = 'status';
						$format_json['parameter'][0]['unity'] = 'nbre';
						$format_json['parameter'][0]['type'] = 'area-spline';
						$format_json['parameter'][0]['color'] = 'esia_state';
						$format_json['data'] = $data;
			
						header('Content-Type: text/json');
						echo json_encode($format_json,JSON_PRETTY_PRINT);
						exit(0);
				}
			}
		}
		else if($_REQUEST['info'] == 'sto_bck_nb'){
			$stats = Model_Backup::getNodesStats($dbconnection,'storage',$_REQUEST['id'],$since);
		
			$data = array();
			foreach($stats as $row){
				$data[$row['name']] = $row['size_count'];
			}
			
			if( isset($_REQUEST['type'])){
				switch($_REQUEST['type']){
					case 'jsonC3' :
						$format_json['parameter'][0]['name'] = 'status';
						$format_json['parameter'][0]['unity'] = 'nbre';
						$format_json['parameter'][0]['type'] = 'area-spline';
						$format_json['parameter'][0]['color'] = null;
						$format_json['data'] = $data;
			
						header('Content-Type: text/json');
						echo json_encode($format_json,JSON_PRETTY_PRINT);
						exit(0);
				}
			}
		}
	}
	http_response_code(400);
}
else http_response_code(404);
exit(0);
?>