<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'Backup');
include_once($path.$arr[0]['apache_path'].'inc/common_page.inc.php');;

$node=Model_esia::InstanceNode($dbconnection,$srv_id);
if($user->getAccess($dbconnection,"device_view",$node->getName()) ==1)
{
	$data = Model_Backup::lastjobbysources($dbconnection,$srv_id);

	foreach($data as $key =>$row){
		$node_name = $row['source'];

		switch(strtolower($data[$key]['type'])){
			case 'full' :
				$data[$key]['type'] = $lang['BCK_TYPE_FULL']; break;
			case 'differential' :
				$data[$key]['type'] = $lang['BCK_TYPE_DIFF']; break;
			case 'incremental' :
				$data[$key]['type'] = $lang['BCK_TYPE_INC']; break;
		}


		//$columns = 'source,end_time,size,type,status,action';
		$columns = 'add,source,name,start_time,size,type,status,message';
		$clang = implode(',',array($lang['ADD'],$lang['BCK_SOURCE'],$lang['BCK_JOB_NAME'],$lang['BCK_DATE'],$lang['BCK_SIZE'],$lang['BCK_TYPE'],$lang['BCK_STATE'],$lang['BCK_MESSAGE']));

		$tab['name'] = 'bck_status_src_ts';
		$tab['title'] = $lang['BCK_SOURCE'].'s';
	}

    $jobsNames = array();
	foreach($data as $k => $job){
		$data[$k]['add']['checkbox'] = array(
				'name'	=> $job['source'],
				'value'	=> $job['source']
		);
        $jobsNames[]=$job['name'];
	}

    $jobsNames = array_unique($jobsNames);

	array_walk($data,'arr_set_status');
	array_walk($data,'arr_parse_size','size,size_min,size_avg,size_max,size_sum');
	array_walk($data,'arr_parse_duration','duration');
	array_walk($data,'arr_parse_date','start_time,end_time');
	array_walk($data,'arr_organize_headers',array($columns,$clang));

	$tab['data'] = $data;
	$smarty->assign('table',$tab);

	$commonName = Model_esia::getCommonName($lang, "CHECK_DB_BACKUPS", "CHECK_DB_BACKUPS");
	$plugin_fields = array_shift(Model_esia::getPlugin($dbconnection,'CHECK_DB_BACKUPS'));
	$parameters = $plugin_fields['parameter'];
	$smarty->assign('admin_checks',array(
	    'check' => 'CHECK_DB_BACKUPS',
	    'common'=>$commonName,
	    'default'=>$parameters
	));

    $parametersJob = $parameters . ' -J';
    $parametersJob=str_replace('"<SRC_NAME>"','"<$JOB_NAME>"',$parametersJob);
    $parametersJob=str_replace('<SRC_NAME>','"<$JOB_NAME>"',$parametersJob);

    $smarty->assign('admin_simplify',array(
                   'check' => 'CHECK_DB_BACKUPS',
                   'common'=>$commonName,
                   'default'=>$parametersJob
    ));
    sort($jobsNames);
    $smarty->assign('admin_objects_list',$jobsNames);

  $smarty->assign('page_id','last');
	$smarty->assign('action','source');
	$smarty->display($template_path.'bck_list_backups_view.html');
}
?>
