<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'Backup');
include_once($path.$arr[0]['apache_path'].'inc/common_page.inc.php');

$node=Model_esia::InstanceNode($dbconnection,$srv_id);
if($user->getAccess($dbconnection,"device_view",$node->getName()) ==1)
{
	$lastbackups = Model_Backup::getBackups($dbconnection,$srv_id,200,-1);
	
	array_walk($lastbackups,'arr_parse_duration','duration');
	array_walk($lastbackups,'arr_parse_date','start_time,end_time');

	array_walk($lastbackups,'arr_set_status');
	
	$data=array();
	foreach($lastbackups as $job){
		$data[] = $job;
	}
	$columns = 'name,source,start_time,type,status,message';
	$clang = implode(',',array($lang['BCK_JOB_NAME'],$lang['BCK_SOURCE'],$lang['BCK_DATE'],$lang['BCK_TYPE'],$lang['BCK_STATE'],$lang['BCK_MESSAGE']));
	array_walk($data,'arr_organize_headers',array($columns,$clang));
	
	$tab['name'] = 'bck_err_backups';
	$tab['title'] = $lang['BCK_TITLE_LAST_BACKUPS'];
	$tab['pager'] = true;
	$tab['tablesorter'] = true;
	$tab['data'] = $data;
	
	$smarty->assign('table',$tab);
	$smarty->display($template_path.'bck_list_backups_view.html');
}
?>
