<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'Backup');
include_once $path.$arr[0]['apache_path'].'inc/common_page.inc.php';
include_once $path.'/Model_adm.php';

$node = Model_esia::InstanceNode($dbconnection,$srv_id);

$isDriverSetted = true;
$logo = $bck_name;
if (empty($bck_name)) {
	$isDriverSetted = false;
	$logo = 'driver_empty';
	if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration"))
	{
		$config = Model_adm::getAdvanceNodeConfig($dbconnection,$node->getId())[0];
		$urlSelectDriver = $config['web_plugin_path'].$config['controller'].'?id='.$config['id'].'&action=update&node='.$node->getId();
		$smarty->assign('url_select_driver',$urlSelectDriver);
	}
}
$smarty->assign('isDriverSetted',$isDriverSetted);
$smarty->assign('logo',$logo);

if($user->getAccess($dbconnection,"device_view",$node->getName()) ==1)
{
	$services = Model_esia::getServices($dbconnection,$srv_id);
	$nbr_service = count($services);
	$smarty->assign('srv_service_count',$nbr_service);
	
	foreach($services as $service)
	{
		
		//on format la sortie pour le HTML
		$out = preg_replace('#\|.*#','',$service['stdout']);
		$list_plugin[]=array('name'=>$service['name'],
				'state'=>$service['state'],
				'time'=>$service['last_exec_time'],
				'stdout'=>$out);
	}
	$smarty->assign('list_plugin', $list_plugin);
	
	$status[$lang['LGD_OK']] = 0;
	$status[$lang['LGD_WARN']] = 0;
	$status[$lang['LGD_CRI']] = 0;
	
	$sources = Model_Backup::lastjobbysources($dbconnection,$srv_id);
	foreach($sources as $source){
		switch($source['esia_status']){
			case 0 :
				$status[$lang['LGD_OK']]++;
				break;
			case 1 :
				$status[$lang['LGD_WARN']]++;
				break;
			case 2 :
				$status[$lang['LGD_CRI']]++;
				break;
		}
	}
	
	$smarty->assign('sourcesstatus',$status);
	
	$lastbackupsall=Model_Backup::getBackups($dbconnection,$srv_id,5,0); //Pour le calcul ordre de dates	
	$lastbackups=Model_Backup::getBackups($dbconnection,$srv_id,5,-1); //Backups errors only
	$lastbackups=array_merge($lastbackups,Model_Backup::getBackups($dbconnection,$srv_id,5,1)); //Backups ok only

	array_walk($lastbackups,'arr_parse_duration','duration');
	array_walk($lastbackupsall,'arr_parse_date_to_duration',array('start_time',array(
			'YEARS'		=> $lang['BCK_YEARS'],
			'MONTHS' 	=> $lang['BCK_MONTHS'],
			'DAYS' 		=> $lang['BCK_DAYS'],
			'HOURS' 	=> $lang['BCK_HOURS'],
			'MINUTES' 	=> $lang['BCK_MINUTES'],
			'SECONDES'	=> $lang['BCK_SECONDES'],
	)));
	array_walk($lastbackups,'arr_parse_date_to_duration',array('start_time',array(
			'YEARS'		=> $lang['BCK_YEARS'],
			'MONTHS' 	=> $lang['BCK_MONTHS'],
			'DAYS' 		=> $lang['BCK_DAYS'],
			'HOURS' 	=> $lang['BCK_HOURS'],
			'MINUTES' 	=> $lang['BCK_MINUTES'],
			'SECONDES'	=> $lang['BCK_SECONDES'],
	)));
	
	//Calcul des dates
	$bydates = array();
	$datesOrder = array();
	foreach($lastbackupsall as $bck){
		if(!isset($bydates[$bck['start_time']])){
			$datesOrder[]=$bck['start_time'];
		}
		$bydates[$bck['start_time']] = array();
	}
	
	foreach($lastbackups as $bck){
		if(isset($bydates[$bck['start_time']])){
			$bydates[$bck['start_time']][] = $bck;
		}
	}
	
	//On recrée une liste
	$tmp = array();
	foreach($datesOrder as $date){
		$tmp = array_merge($tmp,$bydates[$date]);
	}
	
	//On découpe pour avoir les X premiers
	$lastbackups = array_slice($tmp, 0, 5);		
	array_walk($lastbackups,'arr_set_status');
		
	$data=array();
	foreach($lastbackups as $job){
		unset($job['messages']);
		$data[] = $job;
	}
	
	//$columns = 'name,start_time,status,action'
	$columns = 'name,source,start_time,status';
	$clang = implode(',',array($lang['BCK_JOB_NAME'],$lang['BCK_SOURCE'],$lang['BCK_WHEN'],$lang['BCK_STATE'],''));
	array_walk($data,'arr_organize_headers',array($columns,$clang));
	
	$tab['name'] = 'bck_last_backups';
	$tab['title'] = $lang['BCK_TITLE_LAST_BACKUPS'];
	$tab['pager'] = false;
	$tab['tablesorter'] = false;
	$tab['data'] = $data;
	
	$smarty->assign('lastbackups',$tab);
	$smarty->display($template_path.'bck_main.html');
}
?>